--------------------------------------------------------------------------------
-- Weapon firegun + Projectile firep

-- Script by Thecode,September 2010.
--------------------------------------------------------------------------------

-- Setup Tables
if thecode==nil then thecode={} end
thecode.firepgun={}
thecode.firepgun.firep={}

-- Load & Prepare Ressources
thecode.firepgun.gfx_wpn=loadgfx("weapons/lufe.png")					-- Weapon Image
setmidhandle(thecode.firepgun.gfx_wpn)
thecode.firepgun.gfx_pro=loadgfx("weapons/blabla.png")					-- Projectile Image
setmidhandle(thecode.firepgun.gfx_pro)
thecode.firepgun.sfx_attack=loadsfx("launchfire.ogg")					-- Attack Sound
thecode.firepgun.sfx_waterimpact=loadsfx("firefragment.wav")
--------------------------------------------------------------------------------
-- Weapon: firepgun
--------------------------------------------------------------------------------

thecode.firepgun.id=addweapon("thecode.firepgun","firegun",thecode.firepgun.gfx_pro)	-- Add Weapon

function thecode.firepgun.draw()											-- Draw
hudinfo("This weapon doesn't end the turn!")
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,0)
	drawinhand(thecode.firepgun.gfx_wpn,6,0)
	-- HUD chargebar
	if weapon_charge>0 and weapon_shots==0 then
		hudchargebar(weapon_charge,100)
	end
	-- HUD Crosshair
	if weapon_shots==0 then
		hudcrosshair(6,3)
	end
end

function thecode.firepgun.attack(attack)									-- Attack
	if (weapon_shots<=0) then
	useweapon(1)
		-- Charge
		if (attack==1) then
			weapon_charge=weapon_charge+1							-- Increase charge
		end
		-- firep a projectile (on release/full charge)
		if (attack==0 and weapon_charge>0) or (weapon_charge>=100) then
			-- No more weapon switching!
			
			playsound(thecode.firepgun.sfx_attack)
			weapon_shots=weapon_shots+1
			id=createprojectile(thecode.firepgun.firep.id)
			projectiles[id]={}
			-- Ignore collision with current player at beginning
			projectiles[id].ignore=playercurrent()
			-- Set initial position of projectile
			projectiles[id].x=getplayerx(0)+(6*getplayerdirection(0))+math.sin(math.rad(getplayerrotation(0)))*10.0
			projectiles[id].y=getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*10.0
			-- Initial movement
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*20
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*20
			projectiles[id].x=projectiles[id].x-projectiles[id].sx
			projectiles[id].y=projectiles[id].y-projectiles[id].sy
			thecode.firepgun.firep.move(id,0)
			-- Set speed of projectile
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*(weapon_charge/100.0)*10.0
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*(weapon_charge/100.0)*10.0
			-- Effects
			recoil(2)
			-- End Turn
			
		end
	end
end

--------------------------------------------------------------------------------
-- Projectile: firep
--------------------------------------------------------------------------------

thecode.firepgun.firep.id=addprojectile("thecode.firepgun.firep")		-- Add Projectile

function thecode.firepgun.firep.draw(id)							-- Draw
	-- Setup draw mode
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,0)
	setscale(1,1)
	-- Calculate projectile rotation
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	-- Draw projectile
	drawimage(thecode.firepgun.gfx_pro,projectiles[id].x,projectiles[id].y)
	-- Draw Arrow if out of Screen
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function thecode.firepgun.firep.update(id)						-- Update
	-- Move
	thecode.firepgun.firep.move(id,1)
end

function thecode.firepgun.firep.move(id,fx)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	-- Particle Tail
	if (fx==1) then
		particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
		particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
		particlecolor(255,255,0)
		particlefadealpha(0.01)
		particle(p_lightpuff,projectiles[id].x-math.sin(math.rad(rot))*6,projectiles[id].y+math.cos(math.rad(rot))*6)
		particlefadealpha(0.04)
		particlecolor(255,255,0)
	end
	-- Wind + Gravity influence on speed
	projectiles[id].sx=projectiles[id].sx+getwind()
	projectiles[id].sy=projectiles[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		-- Collision
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
				-- Cause damage
				for x=0,40,5 do
				createobject(o_fire,projectiles[id].x,projectiles[id].y)
			end
				arealdamage(projectiles[id].x,projectiles[id].y,30,20)
				-- Destroy terrain
				terrainexplosion(projectiles[id].x,projectiles[id].y,15,1)
				-- Crater
				grey=math.random(0,40)
				if math.random(0,1)==1 then
					terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				else
					terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				end
				-- Free projectile
				freeprojectile(id)
				return 1
			end
		else
			projectiles[id].ignore=0
		end
		-- Water
		if (projectiles[id].y)>getwatery()+5 then
			-- Effects
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(thecode.firepgun.sfx_waterimpact)
			-- Free projectile
			freeprojectile(id)
			return 1
		end
	end
	-- Scroll to projectile
	scroll(projectiles[id].x,projectiles[id].y)
end